// SPDX-License-Identifier: AGPL-3.0-only

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	json "encoding/json"
	"fmt"
	"time"

	v1 "github.com/grafana/grafana-apiserver/pkg/apis/kinds/v1"
	kindsv1 "github.com/grafana/grafana-apiserver/pkg/client/applyconfiguration/kinds/v1"
	scheme "github.com/grafana/grafana-apiserver/pkg/client/clientset/clientset/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// GrafanaResourceDefinitionsGetter has a method to return a GrafanaResourceDefinitionInterface.
// A group's client should implement this interface.
type GrafanaResourceDefinitionsGetter interface {
	GrafanaResourceDefinitions() GrafanaResourceDefinitionInterface
}

// GrafanaResourceDefinitionInterface has methods to work with GrafanaResourceDefinition resources.
type GrafanaResourceDefinitionInterface interface {
	Create(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.CreateOptions) (*v1.GrafanaResourceDefinition, error)
	Update(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.UpdateOptions) (*v1.GrafanaResourceDefinition, error)
	UpdateStatus(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.UpdateOptions) (*v1.GrafanaResourceDefinition, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.GrafanaResourceDefinition, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.GrafanaResourceDefinitionList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.GrafanaResourceDefinition, err error)
	Apply(ctx context.Context, grafanaResourceDefinition *kindsv1.GrafanaResourceDefinitionApplyConfiguration, opts metav1.ApplyOptions) (result *v1.GrafanaResourceDefinition, err error)
	ApplyStatus(ctx context.Context, grafanaResourceDefinition *kindsv1.GrafanaResourceDefinitionApplyConfiguration, opts metav1.ApplyOptions) (result *v1.GrafanaResourceDefinition, err error)
	GrafanaResourceDefinitionExpansion
}

// grafanaResourceDefinitions implements GrafanaResourceDefinitionInterface
type grafanaResourceDefinitions struct {
	client rest.Interface
}

// newGrafanaResourceDefinitions returns a GrafanaResourceDefinitions
func newGrafanaResourceDefinitions(c *KindsV1Client) *grafanaResourceDefinitions {
	return &grafanaResourceDefinitions{
		client: c.RESTClient(),
	}
}

// Get takes name of the grafanaResourceDefinition, and returns the corresponding grafanaResourceDefinition object, and an error if there is any.
func (c *grafanaResourceDefinitions) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.GrafanaResourceDefinition, err error) {
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Get().
		Resource("grafanaresourcedefinitions").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of GrafanaResourceDefinitions that match those selectors.
func (c *grafanaResourceDefinitions) List(ctx context.Context, opts metav1.ListOptions) (result *v1.GrafanaResourceDefinitionList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.GrafanaResourceDefinitionList{}
	err = c.client.Get().
		Resource("grafanaresourcedefinitions").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested grafanaResourceDefinitions.
func (c *grafanaResourceDefinitions) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("grafanaresourcedefinitions").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a grafanaResourceDefinition and creates it.  Returns the server's representation of the grafanaResourceDefinition, and an error, if there is any.
func (c *grafanaResourceDefinitions) Create(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.CreateOptions) (result *v1.GrafanaResourceDefinition, err error) {
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Post().
		Resource("grafanaresourcedefinitions").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(grafanaResourceDefinition).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a grafanaResourceDefinition and updates it. Returns the server's representation of the grafanaResourceDefinition, and an error, if there is any.
func (c *grafanaResourceDefinitions) Update(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.UpdateOptions) (result *v1.GrafanaResourceDefinition, err error) {
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Put().
		Resource("grafanaresourcedefinitions").
		Name(grafanaResourceDefinition.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(grafanaResourceDefinition).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *grafanaResourceDefinitions) UpdateStatus(ctx context.Context, grafanaResourceDefinition *v1.GrafanaResourceDefinition, opts metav1.UpdateOptions) (result *v1.GrafanaResourceDefinition, err error) {
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Put().
		Resource("grafanaresourcedefinitions").
		Name(grafanaResourceDefinition.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(grafanaResourceDefinition).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the grafanaResourceDefinition and deletes it. Returns an error if one occurs.
func (c *grafanaResourceDefinitions) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("grafanaresourcedefinitions").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *grafanaResourceDefinitions) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("grafanaresourcedefinitions").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched grafanaResourceDefinition.
func (c *grafanaResourceDefinitions) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.GrafanaResourceDefinition, err error) {
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Patch(pt).
		Resource("grafanaresourcedefinitions").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// Apply takes the given apply declarative configuration, applies it and returns the applied grafanaResourceDefinition.
func (c *grafanaResourceDefinitions) Apply(ctx context.Context, grafanaResourceDefinition *kindsv1.GrafanaResourceDefinitionApplyConfiguration, opts metav1.ApplyOptions) (result *v1.GrafanaResourceDefinition, err error) {
	if grafanaResourceDefinition == nil {
		return nil, fmt.Errorf("grafanaResourceDefinition provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(grafanaResourceDefinition)
	if err != nil {
		return nil, err
	}
	name := grafanaResourceDefinition.Name
	if name == nil {
		return nil, fmt.Errorf("grafanaResourceDefinition.Name must be provided to Apply")
	}
	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Patch(types.ApplyPatchType).
		Resource("grafanaresourcedefinitions").
		Name(*name).
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// ApplyStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
func (c *grafanaResourceDefinitions) ApplyStatus(ctx context.Context, grafanaResourceDefinition *kindsv1.GrafanaResourceDefinitionApplyConfiguration, opts metav1.ApplyOptions) (result *v1.GrafanaResourceDefinition, err error) {
	if grafanaResourceDefinition == nil {
		return nil, fmt.Errorf("grafanaResourceDefinition provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(grafanaResourceDefinition)
	if err != nil {
		return nil, err
	}

	name := grafanaResourceDefinition.Name
	if name == nil {
		return nil, fmt.Errorf("grafanaResourceDefinition.Name must be provided to Apply")
	}

	result = &v1.GrafanaResourceDefinition{}
	err = c.client.Patch(types.ApplyPatchType).
		Resource("grafanaresourcedefinitions").
		Name(*name).
		SubResource("status").
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
